
//minimal-controller.js

//Global controller
let gController = null;

function log(str) {
	if (AlgoLabModel.getLogSwitch())
		gController.log(str);
}

function println(str) {
	log(str);
}

/* removing -- the js "window" object also has a "print" function,
which we definately don't want to accidently call
function printOLD(str) {
	log(str);
}
*/

//-------------------------------------------------------------

class MinimalController {

	//---------------------------------------------------------
	//Basic

	getElem(nm) {
		//Return field named 'nm'
		return document.getElementById(nm);
	}

	elem(nm) {
		//Alias
		return this.getElem(nm);
	}

	//---------------------------------------------------------
	//Attaching Events (and assuring handler is bound to 'this" object)

	attach(fieldName, eventName, handlerName) {
		if (!this.elem(fieldName))
			throw `Did not find field "${fieldName}" when attaching to handler "${handlerName}"`;
		this.basicAttachEventToHandler(this.elem(fieldName), eventName, handlerName);
	}

	basicAttachEventToHandler(uiElem, eventName, handlerName) {
		/* Attach event to wrapper which actually points to handler.
		Reason for the wrapper is that wrapper is bound to "this" (the
		binding is necessary because methods need to be bound to their object.
		E.g.
			refreshWrapper = refresh (bound to "this")
		*/
		uiElem.addEventListener(eventName, this.handlerForName(handlerName), false);
	}

	handlerForName(handlerName) {
		//Return a copy of the handler method with copy bound to "this"
		//Method "bind" copies receiver, and binds to arg passed (i.e., "this").
		return this[handlerName].bind(this);
	}

	//---------------------------------------------------------
	//Services

	log(text) {
		const
			elem = this.outputElem(),
			content = (elem.value ?? '') + '\n' + text.toString();
		//TRY
		//elem.value = content.trimLeft();
		let lines = content.split('\n');
		if (lines <= 1) return content;
		let index = lines.findIndex(line => line.trim().length > 0);
		if (index === -1) return '';
		elem.value = lines.slice(index).join('\n');
	}

}

//------------------------------------------------------------------

