
/*
source-error-parser.js
class: SourceErrorParser

Model of a source (code) error.
Parsing raw error, etc
*/

//TODO - cleanup below commented out code

class SourceErrorParser {

    constructor(exception, source) {
        this.exception = exception;
        this.source = source;
    }

    static fromException(exception) {
        return new SourceErrorParser(exception);
    }

    //-------------------------------------------------------------

    getErrors() {
        return this.exceptionToDisplayStrings(this.exception);
    }

    //-------------------------------------------------------------
    //Private

    exceptionToDisplayStrings(ex) {
        const strings = [];
        try {
            const lines = ex.stack.split('\n');
            //Assume 0 is info, 1 is location
            strings.push(lines[0]);
            const line2 = lines[1];
            const
                messageLoc = this.parseExceptionMessageLocation(line2),
                fileLoc = this.parseExceptionFileLocation(line2);
            const locationInfo = `("${fileLoc[0]}", line ${fileLoc[1]}) -- in "${messageLoc}()"`;
            strings.push(locationInfo);
        } catch (ex) {
            //nop
        }
        return strings;
    }

    parseExceptionMessageLocation(stackLine) {
        //Expecting something like:
        //	"    at Counter.getCount (file:/
        let key, i, sub;
        key = 'at ';
        i = stackLine.indexOf(key);
        if (i == -1) return '';
        sub = stackLine.substring(i + key.length);
        key = ' ';
        i = sub.indexOf(key);
        if (i == -1) return '';
        return sub.substring(0, i);
    }

    parseExceptionFileLocation(stackLine) {
        //Expecting something like (at end of string):
        //	/model.js:17:5)"
        let i, sub, fn, lineNo;
        i = stackLine.lastIndexOf('/') + 1;
        if (i == -1) return '';
        sub = stackLine.substring(i);
        fn = sub.substring(0, sub.indexOf(':'));
        lineNo = sub.substring(sub.indexOf(':') + 1);
        lineNo = lineNo.substring(0, lineNo.indexOf(':'));
        //TODO - cleanup
        //foo.js (line 101)
        //return `(file="${fn}") (line=${lineNo})`;
        return [fn, lineNo];
    }

}

//-------------------------------------------------------------
SourceErrorParser;