
/*
source-file-simulator.js
class: SourceFileSimulator

Takes source code (a string).
And simulates a source file (to run code).
Reason: so that we can get meaninful errors.
Js does not give helpful errors for running vanilla source code via Function()
*/

//TODO - cleanup below commented out code

class SourceFileSimulator {

    constructor(src) {
        this.src = src;
    }

    load() {
        let scriptId, script, url;
        //assure we have script elem
        scriptId = '_script_sim';
        script = document.getElementById(scriptId);
        if (!script) {
            script = document.createElement('SCRIPT', { id: scriptId });
            document.body.appendChild(script);
        }

        //add url

        //const blob = new Blob([this.src], { type: 'text/javascript' });

        let blob = new Blob([this.src], { type: 'text/javascript' });
        url = URL.createObjectURL(blob);
        fetch(url)
            .then(response => response.blob())
            .then(function(myBlob) {
                const objectUrl = URL.createObjectURL(myBlob);
                script.src = objectUrl;
                //this._script = script;
                //this._url = objectUrl;
            });

        /*
        script.src = url;
        //cache into ivars
        this._script = script;
        this._url = url;
        */
    }

    unload() {
        if (this._url) {
            URL.revokeObjectURL(this._url);
            this._url = null;
        }
        if (this._script) {
            this._script.remove();
            this._script = null;
        }
    }



}


//-------------------------------------------------------------
SourceFileSimulator;