//rectangle.js

//Class that models a simple rectangle with dimensions width and height

class Rectangle {
    /*
    width - the width dimension of a rectangle (an integer)
    height - the height dimension of a rectangle (an integer)
    */

    //--------------------------------------------------------------
    //Public Constructors

    //Returns new Rectangle with width and height set to zero.
    static newRectangle() {
        return Rectangle.fromWidthHeight(0, 0);
    }

    //Returns new Rectangle that is a square with width and height both
    //set to method param "aSide"
    static fromSide(aSide) {
        return Rectangle.fromWidthHeight(aSide, aSide);
    }

    //Returns new Rectangle with width and height set to passed method params
    static fromWidthHeight(aWidth, aHeight) {
        return new Rectangle(aWidth, aHeight);
    }

    //--------------------------------------------------------------
    //Private (Classic) Constructors

    //Classic constructor that accepts width and height params
    constructor(aWidth, aHeight) {
        this.width = aWidth;
        this.height = aHeight;
    }

    //--------------------------------------------------------------
    //Public Instance Methods

    //Compute and return the rectangle perimeter
    //perimeter = 2 * (width + height)
    getPerimeter() {
        return 2 * (this.width + this.height);
    }

}