/*rectangle-test.js

Test code that tests the Rectangle class

Also see "Extensions" at bottom of this file

EDIT INSTRUCTIONS:

	1. Change name of class RectangleTest for your model.
		(e.g., if testing class "Stack", rename RectangleTest to StackTest.

	2. Code tests -- add/remove/edit the example tests with
		your test code (your test code may follow the examples closely)

	3. In "run" method, edit tests as appropriate so they call tests
		coded in step #2.

*/

//---------------------------------------

class RectangleTest {

	//---------------------------------------
	// Public

	run() {
		//run experiments
		this.basicRun('smokeTest_construct_newRectangle');
		this.basicRun('smokeTest_construct_fromSide');
		this.basicRun('smokeTest_construct_fromWidthHeight');
		this.basicRun('test_getPerimeter_1');
	}

	//---------------------------------------
	//Constructor Smoke Tests

	smokeTest_construct_newRectangle() {
		//We will simply test that the constructors run without crashing (without throwing an exception)
		let rectangle = Rectangle.newRectangle();
		//If we get here, constructor did not "crash", so we pass
		this.println('PASSED');
	}

	smokeTest_construct_fromSide() {
		//We will simply test that the constructors run without crashing (without throwing an exception)
		let rectangle = Rectangle.fromSide(8);
		//If we get here, constructor did not "crash", so we pass
		this.println('PASSED');
	}

	smokeTest_construct_fromWidthHeight() {
		//We will simply test that the constructors run without crashing (without throwing an exception)
		let rectangle = Rectangle.fromWidthHeight(10, 5);
		//If we get here, constructor did not "crash", so we pass
		this.println('PASSED');
	}

	//---------------------------------------
    //Public Instance Method Tests

	test_getPerimeter_1() {
		//test actual vs expected
		//square with side=8 has perimeter 8 * 4 = 32
		var expected, actual, rectangle, msg;
		expected = 32;
		rectangle = Rectangle.fromSide(8);
		actual =rectangle.getPerimeter();
		msg = actual.equals(expected) ? 'PASSED' : 'FAILED';
		this.println(msg);
	}

	//---------------------------------------
	// Helpers

	basicRun(methodName) {
		//we bind so the method is associated with this object
		var myMethod = this[methodName];
		if (myMethod == null) {
			this.println(`ERROR -- Could not find test method "${methodName}"`);
			return;
		}
		myMethod = myMethod.bind(this);
		this.println(`Starting - ${methodName}`);
		try {
			myMethod();
		} catch(ex) {
			this.println(`EXCEPTION OCCURRED in ${methodName} -- ${ex.message}`);
		}
		this.println(`Finished - ${methodName}\n`);
	}

	println(o) {
		this.printFct(o);
	}

	//---------------------------------------
	// Accessors

	setPrintFct(aPrintFct) {
		this.printFct = aPrintFct;
	}

	getPrintFct() {
		return this.printFct;
	}

}

//---------------------------------------
//Extensions

Object.prototype.equals = function(other) {
    //Default implementation here, classes override as needed
	//Note: we do this extension so proper objects can be compared in future tests
    if (Array.isArray(this) && Array.isArray(other))
        return arraysEqual(this, other);
    return (other != null) && this == other;
}

Array.prototype.equals = function(other) {
    //Overriding for arrays
    if (!Array.isArray(other))
		return false;
	var a1, a2;
	a1 = this;
	a2 = other;
	if (a1.length !== a2.length)
        return false;
    for (let i=0; i<a1.length; i++)
        if (!a1[i].equals(a2[i]))
            return false;
    return true;
}

