/* test-controller.js
		The event manager and interface between the view and model

EDIT INSTRUCTIONS:

	1. In the method "constructor", change "RectangleTest" so
		that it references your test class.

*/

class TestController {

	//----------------------------
	// Initiazation

	constructor() {
		this.test = new RectangleTest();
		this.test.setPrintFct(obj => this.println(obj));
	}

	attachEvents() {
		this.getElem('runId').addEventListener('click', this['clickedGo'].bind(this), false);
		this.getElem('clearId').addEventListener('click', this['clickedClear'].bind(this), false);
		window.addEventListener("keyup", this.keyupWindow.bind(this), false);
	}

	//----------------------------
	// Event Handlers

	clickedGo() {
		this.test.run();
		//this.println("HELLO");
	}

	clickedClear() {
		let o = this.outputElem();
		o.innerText = '';
	}

	keyupWindow(evt) {
		// "13" is Enter Key
		if (evt.keyCode === 13) {
			evt.preventDefault();
			this.clickedGo();
		}
	}

	//----------------------------
	//Helpers

	getElem(nm) {
		//Return field named 'nm'
		return document.getElementById(nm);
	}

	outputElem() {
		return this.getElem('outputId');
	}

	println(object) {
		let o = this.outputElem();
		o.innerText = o.innerText + "\n" + object.toString();
	}

}

//=========================================================================
//Global Controller

let gController = null;

function buildController() {
	//one and only controller (global)
	gController = new TestController();
	gController.attachEvents();
}

document.onreadystatechange = function () {
	if(document.readyState === 'complete') {
		try {
			buildController();
		} catch(ex) {
			alert('See console for more information\n' + ex.message);
		}
	}
}